#include <reg52.h>       /* special function register declarations   */
#include <absacc.h>      /* for the intended 8051 derivative         */
#include <stdio.h>       /* prototype declarations for I/O functions */

                             /*     dp  g   f   e   d   c   b   a   */
unsigned char tab[]={ 0x3f,  /* 0:  0   0   1   1   1   1   1   1   */
                      0x06,  /* 1:  0   0   0   0   0   1   1   0   */
                      0x5b,  /* 2:  0   1   0   1   1   0   1   1   */
                      0x4f,  /* 3:  0   1   0   0   1   1   1   1   */
                      0x66,  /* 4:  0   1   1   0   0   1   1   0   */
                      0x6d,  /* 5:  0   1   1   0   1   1   0   1   */
                      0x7d,  /* 6:  0   1   1   1   1   1   0   1   */
                      0x27,  /* 7:  0   0   1   0   0   1   1   1   */
                      0x7f,  /* 8:  0   1   1   1   1   1   1   1   */
                      0x6f,  /* 9:  0   1   1   0   1   1   1   1   */
                      0x77,  /* a:  0   1   1   1   0   1   1   1   */
                      0x7c,  /* b:  0   1   1   1   1   1   0   0   */
                      0x39,  /* c:  0   0   1   1   1   0   0   1   */
                      0x5e,  /* d:  0   1   0   1   1   1   1   0   */
                      0x79,  /* e:  0   1   1   1   1   0   0   1   */
                      0x71,  /* f:  0   1   1   1   0   0   0   1   */
                      0x00,  /*  :  0   0   0   0   0   0   0   0   */
                      0x40   /* -:  0   1   0   0   0   0   0   0   */
                    };

unsigned char ScanPos = 0;
unsigned char dis[6];
unsigned char Dig[2] = {
  0x01, 0x02
};

unsigned char x, y;

unsigned char KEY;
unsigned char BpState = 0;

unsigned char timer=0;

unsigned char RxBuf[32];
unsigned char RxBufTopPtr = 0;
unsigned char RxBufBtmPtr = 0;

void main (void)  
{
  TMOD |= 0x01;   
  TH0 = 0xf7;
  TR0 = 1;
  
  TMOD |= 0x20;
  TH1 = 0xfd;
  TR1 = 1;
  SCON = 0x5a;
  
  IE |= 0x82;
  
  XBYTE[0x8020] = 0x01;
  TI = 1;
  
  while (1)
  {
    if(timer > 200) 
		{
			timer = 0;      
      dis[1] = KEY&0x0f;
      dis[0] = KEY>>4;
    }
    
    if(RI != 0)
    {
      RI = 0;
      RxBuf[RxBufBtmPtr] = SBUF;
      RxBufBtmPtr = (RxBufBtmPtr+1)&0x1f;
    }
    
    if((TI != 0)&&(RxBufTopPtr != RxBufBtmPtr))
    {
      TI = 0;
      SBUF = RxBuf[RxBufTopPtr];
      RxBufTopPtr = (RxBufTopPtr+1)&0x1f;
    }    
  }                              
}

void T0IntSer(void) interrupt 1
{
  TH0=0xf7;
  
  XBYTE[0x8060] = 0x00;
  XBYTE[0x8061] = Dig[ScanPos];
  XBYTE[0x8060] = tab[dis[ScanPos]];
  x = XBYTE[0x8060];
  x <<= ScanPos*4;
  KEY &= ~(0x0f<<ScanPos*4);
  KEY |= x;
  ScanPos = (ScanPos+1)&0x01;
  
  timer++;
}
